- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnCharacter Class Reference

# OpenMayaAnim - API module for animation | FunctionSet classes

Search for all occurrences

## Detailed Description

Function Set for Characters.

Maya offers "character" nodes to simplify the setting of keyframes on collections of attributes. The implementation of the "character" is a sub-class of MFnSet taking advantage of the fact that attributes can be represented as MObjects and can be made members of a set. The fact that sets also derive from MObject means that characters may have other character sets as members thus establishing a hierarchy. Only attributes and characters can be members of a character set. The character node will disallow the addition of other objects to its set.

Character sets are also part of a partition, meaning that membership of character sets cannot overlap with other character sets. Thus, when an attribute already in a character is added to another character it must be removed from the original character.

Characters are integral to Maya's nonlinear animation system, "Trax". Trax allows the user to create "animation clips", which bundle a set of animation curves so that they can be reused multiple times, with different timing then the original clip. When a clip is created, Maya finds the the animation curves that are attached to the attributes in the character set and moves those animation curves into the newly created clip. The MFnClip function set is the Maya function set for clips.

Clips in maya can be of two types: source clips and scheduled clips. In the Maya UI, source clips are visible in the Visor while scheduled clips are visible in Trax. A source clip contains the animation curves for the clip. An scheduled clip contains data about the placement of an instance of a source clip in the Maya timeline. In this context, an "instance" means that the animation curves from the source clip are shared by the scheduled clip. Scheduled clips never contain their own animation curves, they always refer to a source clip's curves.

For example, if you create a clip called "run" in maya that lasts from frames 1-20, a source clip node will be created with a start of 1, a duration of 19, and dependency graph connections to all of the animation curves that make up the "run". If you then place an instance of the run clip at frame 5 and another instance of the run clip at frame 20, you have 2 scheduled clips: one with a start frame of 5 and one with a start frame of 20. As mentioned in the previous paragraph, only a single set of animation curves exist for the run regardless of the number of times the run is scheduled.

Trax also allows you to create "blends" between clips, which enable you to control the transition between the clips. A blend is represented in the dependency graph by an "animBlendInOut" node, which uses an animation curve to determine the transition type.

In the dependency graph, when a character has animation clips, the character node will always be connected to a "clipLibrary" node and a "clipScheduler" node. The clipLibrary node is connected to all of the source clips and their animation curves. The clipScheduler node is connected to the scheduled clips and blends. It is the clipScheduler that computes the final animation by looking at the placement and overlap of the clips and feeding the attribute data back into the character set.

Examples:

  createClipCmd.cpp.

`#include <MFnCharacter.h>`

Inheritance diagram for MFnCharacter:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnCharacter ()
| Destructor.
| MFnCharacter ()
| Default constructor.
| MFnCharacter (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
MStatus | attachSourceToCharacter (MObject &sourceClip, MDGModifier &dgMod)
| Attaches a given source clip node (created using MFnClip::createSourceClip) to the character's clipLibrary.
MStatus | attachInstanceToCharacter (MObject &instanceClip, MDGModifier &dgMod)
| Attaches an instance of a clip to the character.
MStatus | addCurveToClip (MObject &curve, MObject &sourceClip, MPlug &characterPlug, MDGModifier &dgMod)
| Adds an animation curve to a clip.
MObject | createBlend (MObject &instancedClip1, MObject &instancedClip2, MObject &blendAnimCurve, MDGModifier &dgMod, MStatus *ReturnStatus=NULL)
| Creates a blend between two instanced clips on the character.
bool | blendExists (MObject &instancedClip1, MObject &instancedClip2, MObject &blendResult)
| Return true if a blend exists between the two instanced clips on the character.
bool | removeBlend (MObject &instancedClip1, MObject &instancedClip2, MDGModifier &dgMod, MStatus *ReturnStatus=NULL)
| Remove the blend between the two instanced clips on the character.
bool | getCharacterThatOwnsPlug (MPlug &plug, MObject &result) const
| Given a plug, test the plug to see if it is owned by a character.
MStatus | getMemberPlugs (MPlugArray &result) const
| Get the members of the character set that are attributes.
MStatus | getSubCharacters (MSelectionList &result) const
| Get a list of the subcharacters that are members of the character set.
MObject | getClipScheduler (MStatus *ReturnStatus=NULL)
| Get the clipScheduler node that manages the playback of clips on this character.
int | getScheduledClipCount (MStatus *ReturnStatus=NULL)
| Return the number of clips that have been scheduled on this character.
MObject | getScheduledClip (int index, MStatus *ReturnStatus=NULL)
| Return the scheduled animClip node corresponding to the specified index.
int | getSourceClipCount (MStatus *ReturnStatus=NULL)
| Return the number of source clips managed by the clipLibrary node of this character.
MObject | getSourceClip (int index, MStatus *ReturnStatus=NULL)
| Return the animClip node corresponding to the specified index.
int | getBlendCount (MStatus *ReturnStatus=NULL)
| Return the number of blends that have been added to clips on this character.
MObject | getBlend (int index, MStatus *ReturnStatus=NULL)
| Return the animBlendInOut node corresponding to the specified index.
MStatus | getBlendClips (int index, MObject &clip1, MObject &clip2)
| Returns the clip nodes that are blended by the blend node corresponding to the specified index.
| MFnCharacter (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

MFnCharacter | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnCharacter | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kCharacter.

Reimplemented from MFnSet.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnCharacter".

Reimplemented from MFnSet.

MStatus attachSourceToCharacter | ( | MObject & | sourceClip,
|  | MDGModifier & | dgMod
| ) |  |

Search for all occurrences

Attaches a given source clip node (created using MFnClip::createSourceClip) to the character's clipLibrary.

Attaches a clipLibrary and clipScheduler to the character if they are not attached already.

Parameters:

  [in] | sourceClip | source clip to be attached
  [in] | dgMod | command modifier used for undo and redo

Returns:
  The return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed
  - MS::kInsufficientMemory out of memory

Examples:
  createClipCmd.cpp.

MStatus attachInstanceToCharacter | ( | MObject & | instanceClip,
|  | MDGModifier & | dgMod
| ) |  |

Search for all occurrences

Attaches an instance of a clip to the character.

If the source clip related to the clip instance is not already attached to the character, it will be attached as well.

This command will fail if the instanced clip passed in is not associated with a source clip. The best way to associate an instanced clip with a source clip is to create the instanced clip using MFnClip::createInstancedClip.

Parameters:

  [in] | instanceClip | the animClip node representing the clipInstance
  [in] | dgMod | command modifier used for undo and redo

Returns:
  The return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed
  - MS::kInsufficientMemory out of memory

Examples:
  createClipCmd.cpp.

MStatus addCurveToClip | ( | MObject & | curve,
|  | MObject & | sourceClip,
|  | MPlug & | plug,
|  | MDGModifier & | dgMod
| ) |  |

Search for all occurrences

Adds an animation curve to a clip.

The user must provide the animation curve, and the related source clip node (typically created using MFnCharacter::createSourceClip). The user must also specify the plug that the clip will drive. The plug must be a member of the character managed by this MFnCharacter.

Parameters:

  [in] | curve | the animation curve to be added to the clip
  [in] | sourceClip | a source clip specifying the start and duratiohn of the clip
  [in] | plug | plug that this animCurve will drive
  [in] | dgMod | command modifier used for undo and redo

Returns:
  The return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed
  - MS::kInsufficientMemory out of memory

Examples:
  createClipCmd.cpp.

MObject createBlend | ( | MObject & | instancedClip1,
|  | MObject & | instancedClip2,
|  | MObject & | blendAnimCurve,
|  | MDGModifier & | dgMod,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a blend between two instanced clips on the character.

The blend is defined by a specified paramCurve, which should be keyed between times of 0 and 1. Time 0 corresponds to the start time of the blend. Time 1 corresponds to the end time of the blend. The blend will be performed on the clips according to the keyed value of the blend curve, using the equation: (value)*clip1 + (1-value)*clip2. For example, let's say the blend curve goes from a value of (0,0) to (1,1). At the start of the blend you will have 100% of clip1, and 0% of clip2. At the end of the blend you will have 0% of clip1, and 100% of clip2.

Parameters:

  [in] | instancedClip1 | clip to be blended
  [in] | instancedClip2 | another clip to be blended
  [in] | blendAnimCurve | animCurve defining the type of the blend
  [in] | dgMod | command modifier used for undo and redo
  [out] | ReturnStatus | return status

Returns:
  The resulting animBlend node

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed
  - MS::kInsufficientMemory out of memory

bool blendExists | ( | MObject & | instancedClip1,
|  | MObject & | instancedClip2,
|  | MObject & | blendResult
| ) |  |

Search for all occurrences

Return true if a blend exists between the two instanced clips on the character.

If a blend exists, the animBlend node related to the blend is also returned.

Parameters:

  [in] | instancedClip1 | clip
  [in] | instancedClip2 | another clip
  [in] | blendResult | the blend, if a blend is found

Returns:
  true, if a blend was found between the two clips

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed
  - MS::kInsufficientMemory out of memory

bool removeBlend | ( | MObject & | instancedClip1,
|  | MObject & | instancedClip2,
|  | MDGModifier & | dgMod,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Remove the blend between the two instanced clips on the character.

If a blend exists and was deleted, returns true. If a blend did not exist, returns false.

Parameters:

  [in] | instancedClip1 | clip
  [in] | instancedClip2 | another clip
  [in] | dgMod | command modifier used for undo and redo
  [out] | ReturnStatus | the return status

Returns:
  true, if a blend was found and deleted

bool getCharacterThatOwnsPlug | ( | MPlug & | plug,
|  | MObject & | result
| ) |  | const

Search for all occurrences

Given a plug, test the plug to see if it is owned by a character.

If a character controls this plug, the character will be returned

Parameters:

  [in] | plug | MPlug containing a plug for which you want to find the related character
  [in] | result | Mobject containing a character if the plug is in a character, else an empty MObject

Returns:
  true, if the plug is in a character

MStatus getMemberPlugs | ( | MPlugArray & | result | ) | const

Search for all occurrences

Get the members of the character set that are attributes.

Return them as a plug array. A character set can contain only attributes and subcharacters. To get all of the members of the character, use MFnSet::getMembers. To get the subcharacters, use MFnCharacter::getSubcharacters.

Parameters:

  [out] | result | storage for the returned list of members

Returns:
  Return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object
  - MS::kInsufficientMemory out of memory

Examples:
  createClipCmd.cpp.

MStatus getSubCharacters | ( | MSelectionList & | result | ) | const

Search for all occurrences

Get a list of the subcharacters that are members of the character set.

Parameters:

  [out] | result | storage for the returned list of members

Returns:
  Return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object
  - MS::kInsufficientMemory out of memory

MObject getClipScheduler | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Get the clipScheduler node that manages the playback of clips on this character.

If no clips have been created for this character, this method will return an empty MObject.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  MObject containing a clipScheduler node

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object

int getScheduledClipCount | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the number of clips that have been scheduled on this character.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Number of clips scheduled on this character

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object

MObject getScheduledClip | ( | int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Return the scheduled animClip node corresponding to the specified index.

The specified index should range from 0 to clipCount-1 where clipCount is the value returned by MFnCharacter::getScheduledClipCount.

Parameters:

  [in] | index | Clip index.
  [out] | ReturnStatus | return status

Returns:
  MObject containing an animClip node

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object
  - MS::kIndexOutOfRange this index given exceeded the total clip count
  - MS::kObjectDoesNotExist the clip node for this index does not exist, indicates a missing connection in the dependency graph

int getSourceClipCount | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the number of source clips managed by the clipLibrary node of this character.

For more information on source clips, refer to the description of the MFnCharacter node.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Number of source clips owned by the library on this character

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object

MObject getSourceClip | ( | int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Return the animClip node corresponding to the specified index.

The animClip node will be a source clip node. The specified index should range from 0 to clipCount-1 where clipCount is the value returned by MFnCharacter::getSourceClipCount.

Parameters:

  [in] | index | Clip index.
  [out] | ReturnStatus | Return status.

Returns:
  MObject containing an animClip node

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object
  - MS::kIndexOutOfRange this index given exceeded the total clip count
  - MS::kObjectDoesNotExist the clip node for this index does not exist, indicates a missing connection in the dependency graph

int getBlendCount | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Return the number of blends that have been added to clips on this character.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Number of blends on clips in this character

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object

MObject getBlend | ( | int | index,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Return the animBlendInOut node corresponding to the specified index.

Parameters:

  [in] | index | Index of the desired node.
  [out] | ReturnStatus | return status

Returns:
  MObject containing an animBlendInOut node

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object
  - MS::kIndexOutOfRange this index given exceeded the total blend count
  - MS::kObjectDoesNotExist the blend node for this index does not exist, indicates a missing connection in the dependency graph or that no blend exists

MStatus getBlendClips | ( | int | index,
|  | MObject & | clip1,
|  | MObject & | clip2
| ) |  |

Search for all occurrences

Returns the clip nodes that are blended by the blend node corresponding to the specified index.

Parameters:

  [in] | index | the index of the blend
  [out] | clip1 | the first of the clips being blended
  [out] | clip2 | the second of the clips being blended

Returns:
  Return status

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure this function set does not have a valid character object
  - MS::kIndexOutOfRange this index given exceeded the total blend count
  - MS::kObjectDoesNotExist the clip nodes for this index do not exist, indicates a missing connection in the dependency graph or an invalid blend

MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter
MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter MFnCharacter